import { ObjectRowTable, ArrayRowTable, TableBatch } from '@loaders.gl/schema';
import { parseNDJSONSync } from "./lib/parsers/parse-ndjson.js";
import { parseNDJSONInBatches } from "./lib/parsers/parse-ndjson-in-batches.js";
export declare const NDJSONLoader: {
    readonly dataType: ArrayRowTable | ObjectRowTable;
    readonly batchType: TableBatch;
    readonly name: "NDJSON";
    readonly id: "ndjson";
    readonly module: "json";
    readonly version: any;
    readonly extensions: ["ndjson", "jsonl"];
    readonly mimeTypes: ["application/x-ndjson", "application/jsonlines", "application/json-seq"];
    readonly category: "table";
    readonly text: true;
    readonly parse: (arrayBuffer: ArrayBuffer) => Promise<ArrayRowTable | ObjectRowTable>;
    readonly parseTextSync: typeof parseNDJSONSync;
    readonly parseInBatches: typeof parseNDJSONInBatches;
    readonly options: {};
};
//# sourceMappingURL=ndjson-loader.d.ts.map